function x_ann = annobs(x,freq)

%======================================================================
%  NOTES:
%  Code written by Wacther (2013, Journal of Finance)
%======================================================================

%convert a state variable observed with a given frequency into
%annual observations.  

%Note that there is one more observation for the state variables as
%opposed to the flow variables; this is taken into account.

%For example, suppose that the frequency equals 4, and there are 5
%years in the simulation.  We have 21 total observations of the
%state variable and save the 1st, 5th, 9th, 13th, 17th, and 21st.

T = length(x)-1;
if mod(T,freq)~=0
  warning('sequence of inappropriate length')
end

xtemp = reshape(x(2:end)',freq,T/freq);
x_ann = [x(1); xtemp(end,:)'];