    function S = paramstructbase

% -------------------------------------------------------------------------
% Calibration 
% -------------------------------------------------------------------------
S = struct('beta',  0.024,      ... % Rate of time preference
           'gamma',  10,       ... % Coefficient of relative risk aversion
           'psi',    1.5,       ... % Elasticity of intertemporal substitution
           'mu_bar',  0.018,    ... % Drift consumption growth (Long run growth of consumption)
           'v_bar',  0.027^2,... % Drift volatility growth (Long run volatility of consumption)
           'kappa_mu',  0.256,  ... % Mean reversion of expected consumption growth
           'kappa_v',  0.156,  ... % Mean reversion of volatility
           'nu_mu', 0.044*12,      ... % Volatility consumption growth
           'nu_v',  0.0035,    ... % Volatility of volatility
           'n',     7,          ...  % Number of grid points (75 does a great job)
           'maxitLogLin',10000, ... % Max number of iterations for log-linear approximation;
           'crit',  10^(-6),    ... % Stopping rule
           'freq',  1,         ... % Sampling frequency, e.g., 12 is monthly, 4 is quarterly and 1 is annualy
           'Tsim',  50,         ... % Number of years to simulate (840 monthly obs, 78 years in BY)
           'burn_in',0,        ... % Burn-in sample in years
           'MCsim', 5000,        ... % Number of repetitions of simulation
           'prec',  12        ... % Sampling precision (should be a multiple of the observation frequency)
            );

return

% End-of-file