function delc = sim_c(mu,v,T,freq,prec)
%----------------------------------------------------------------------
% PURPOSE: Simulate consumption process
%======================================================================
%  NOTES:
%  Modified from the code written by Wacther (2013, Journal of Finance)
%======================================================================

%======================================================================
%  INITIALIZATIONS
%======================================================================

if length(mu)~=T*freq*prec+1 && length(v)~=T*freq*prec+1
  error('mu and v vectors of wrong length')
end

%shocks during normal times
vv  = randn(T*freq*prec+1,1);

%log consumption growth
delc = (mu-.5*v)/(freq*prec) + sqrt(v)/sqrt(freq*prec).*vv;

% End-of-file


