%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Asset pricing
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if loop > 999 sample = num2str(loop); end
if loop < 1000 sample = ['0',num2str(loop)]; end
if loop < 100 sample = ['00',num2str(loop)]; end
if loop < 10 sample = ['000',num2str(loop)]; end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Loading data for model
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 1 Lucas' fruit tree economy (two assets)
if (solution == 1) 
    RP = gamma*sigma_bar^2+exp(-gamma*nu_bar)*(1-exp(nu_bar))*lambda;
    
%     load(['Data/Draw_' startdate '/Samples/'  'RES_SAMP.mat']);   
%     load(['Data/Draw_' startdate '/Samples/'  'RES_SAMP2.mat']);

    y=outr_y(:,loop); 
    Asim = (exp(y));
    
    Asim_init = 1;
    if (size(Asim,1)>1)
        Asim=Asim'; 
    end
    Aobs = Asim(index_obs==1);
    Aann = Asim(index==1);

    gsim = (log(Asim)-log([Asim_init Asim(1:(end-1))]));
    gobs = (log(Aobs)-log([Asim_init Aobs(1:(end-1))]));
    gann = (log(Aann)-log([Asim_init Aann(1:(end-1))]));

    xnorm=outr_xnorm(:,loop);
    xnorm2=outr_xnorm2(:,loop);
    xnorm3=outr_xnorm3(:,loop);
    Bsim = cumsum(xnorm)*sqrt(prec);
    Zsim = cumsum(xnorm2)*sqrt(prec);
    Z2sim = cumsum(xnorm3)*sqrt(prec);
    if (size(Bsim,1)>1)
        Bsim=Bsim'; 
    end
    if (size(Zsim,1)>1)
        Zsim=Zsim'; 
    end
    if (size(Z2sim,1)>1)
        Z2sim=Z2sim'; 
    end
    Bsim_init=0;
    Zsim_init=0;
    Z2sim_init=0;
    Bobs = Bsim(index_obs==1);
    Zobs = Zsim(index_obs==1);
    Z2obs = Z2sim(index_obs==1);
    Bann = Bsim(index==1);
    Zann = Zsim(index==1);
    Z2ann = Z2sim(index==1);

    xpois=outr_xpois(:,loop);
    Nsim = xpois;

    if (quiet ==1)    
        Nsim(1:end)=0;
    end
    if (size(Nsim,1)>1)
        Nsim=Nsim'; 
    end
    Nsim_init=0;
    Nobs = Nsim(index_obs==1);
    Nann = Nsim(index==1);
    
    N2obs = 0;

    xdefs_in=outr_xdefs(:,loop);     
    xdefs=repmat(xdefs_in(1),xdefs_in(2),1);
    if (size(xdefs,1)>1)
        xdefs=xdefs';
    end
    
    dxsim =(Nsim-[Nsim_init Nsim(1:(nPeriods/prec-1))]);
    dxobs =(Nobs-[Nsim_init Nobs(1:(nPeriods/freq-1))]);
    dxann =(Nann-[Nsim_init Nann(1:(nPeriods-1))]);
    nusim=(1:nPeriods/prec);
    nuobs=(1:nPeriods/freq);
    nuann=(1:nPeriods);
    desim=nusim(dxsim>=1);
    deobs=nuobs(dxobs>=1);
    deann=nuann(dxann>=1);
    Dsim = dxsim; Dsim(desim)= xdefs(1:length(desim));
    Dobs = dxobs; Dobs(deobs)= xdefs(1:length(deobs));
    Dann = dxann; Dann(deann)= xdefs(1:length(deann));

    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Asset pricing
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    % equilibrium interest rate
    r = rho+gamma*mu_bar-.5*gamma*(1+gamma)*sigma_bar^2+lambda-(1-(1-exp(kappa))*q)*exp(-gamma*nu_bar)*lambda;

    % stochastic discount factor
    SDFsim = exp(-(rho+gamma*mu_bar-.5*gamma*sigma_bar^2)*prec-gamma*sigma_bar*(Bsim-[Bsim_init Bsim(1:(nPeriods/prec-1))])-gamma*nu_bar*(Nsim-[Nsim_init Nsim(1:(nPeriods/prec-1))]));
    SDFobs = exp(-(rho+gamma*mu_bar-.5*gamma*sigma_bar^2)*freq-gamma*sigma_bar*(Bobs-[Bsim_init Bobs(1:(nPeriods/freq-1))])-gamma*nu_bar*(Nobs-[Nsim_init Nobs(1:(nPeriods/freq-1))]));
    SDFann = exp(-(rho+gamma*mu_bar-.5*gamma*sigma_bar^2)-gamma*sigma_bar*(Bann-[Bsim_init Bann(1:(nPeriods-1))])-gamma*nu_bar*(Nann-[Nsim_init Nann(1:(nPeriods-1))]));

    % price of a claim of next period's output
    Psim_risk = exp((-rho+(1-gamma)*mu_bar-.5*(1-gamma)*sigma_bar^2+.5*(1-gamma)^2*sigma_bar^2+(exp((1-gamma)*nu_bar)-1)*lambda)*prec)*Asim; Psim_init=exp((-rho+(1-gamma)*mu_bar-1/2*(1-gamma)*sigma_bar^2+1/2*(1-gamma)^2*sigma_bar^2+(exp((1-gamma)*nu_bar)-1)*lambda)*prec)*Asim_init;
    Pobs_risk = Psim_risk(index_obs==1);
    Pann_risk = Psim_risk(index==1);

    % price of the government bill with default risk
    Psim_bill = exp((-(rho-r+gamma*mu_bar-.5*gamma*sigma_bar^2)+.5*(gamma*sigma_bar)^2+q*(exp(kappa-gamma*nu_bar)-1)*lambda+(1-q)*(exp(-gamma*nu_bar)-1)*lambda)*prec)*Asim; Psim_bill_init=exp((-(rho-r+gamma*mu_bar-.5*gamma*sigma_bar^2)+.5*(gamma*sigma_bar)^2+q*(exp(kappa-gamma*nu_bar)-1)*lambda+(1-q)*(exp(-gamma*nu_bar)-1)*lambda)*prec)*Asim_init;
    Pobs_bill = Psim_bill(index_obs==1);
    Pann_bill = Psim_bill(index==1);

    % equilibrium risk free rate
    Rsim_free = exp((r-exp(-gamma*nu_bar)*(1-exp(kappa))*q*lambda)*prec).*ones(nPeriods/prec,1)';
    Robs_free = exp((r-exp(-gamma*nu_bar)*(1-exp(kappa))*q*lambda)*freq).*ones(nPeriods/freq,1)';
    Rann_free = exp(r-exp(-gamma*nu_bar)*(1-exp(kappa))*q*lambda).*ones(nPeriods,1)';

    % return on the risky claim
    Rsim_risk = exp((rho+gamma*mu_bar-.5*gamma*sigma_bar^2-.5*(1-gamma)^2*sigma_bar^2-(exp((1-gamma)*nu_bar)-1)*lambda)*prec+sigma_bar*(Bsim-[Bsim_init Bsim(1:(nPeriods/prec-1))])+nu_bar*(Nsim-[Nsim_init Nsim(1:(nPeriods/prec-1))]));
    Robs_risk = exp((rho+gamma*mu_bar-.5*gamma*sigma_bar^2-.5*(1-gamma)^2*sigma_bar^2-(exp((1-gamma)*nu_bar)-1)*lambda)*freq+sigma_bar*(Bobs-[Bsim_init Bobs(1:(nPeriods/freq-1))])+nu_bar*(Nobs-[Nsim_init Nobs(1:(nPeriods/freq-1))]));
    Rann_risk = exp(rho+gamma*mu_bar-.5*gamma*sigma_bar^2-.5*(1-gamma)^2*sigma_bar^2-(exp((1-gamma)*nu_bar)-1)*lambda+sigma_bar*(Bann-[Bsim_init Bann(1:(nPeriods-1))])+nu_bar*(Nann-[Nsim_init Nann(1:(nPeriods-1))]));
    % Rann_risk_mean = exp(rho+gamma*mu_bar+.5*(1-gamma)*gamma*sigma_bar^2-(exp(-gamma*nu_bar)-1)*exp(nu_bar)*lambda);

    % return on the bill with default risk
    Rsim_bill = exp(r*prec+Dsim);
    Robs_bill = exp(r*freq+Dobs);
    Rann_bill = exp(r+Dann);

    % adding measurement errors
    Robs_free_measured = Robs_free.*exp(eta*(Zobs-[Zsim_init Zobs(1:(nPeriods/freq-1))]));
    Robs_risk_measured = Robs_risk.*exp(10*eta*(Z2obs-[Z2sim_init Z2obs(1:(nPeriods/freq-1))]));
    
    % observed mean Euler equation errors (conditional on no disasters)
    euler_bill = (exp((-(exp(-nu_bar*gamma)-1)*lambda+exp(-gamma*nu_bar)*(1-exp(kappa))*q*lambda)*freq)-1);
    euler_risk = (exp((-(exp((1-gamma)*nu_bar)-1)*lambda)*freq)-1);
    
end

% 3 neoclassical growth model
if (solution == 3) 
    % removing initial period after sampling
    if (loop == 1) 
        nPeriods = nPeriods-1; 
    end
    RP = alpha*gamma*sigma^2+exp(-alpha*gamma*nu)*(1-exp(nu))*lambda2;

%     load(['Data/Draw_' startdate '/Samples/'  'RES_SAMP.mat']);   
%     load(['Data/Draw_' startdate '/Samples/'  'RES_SAMP2.mat']);   
    
    rsim=outr_rsim(:,loop); 
    
    if (size(rsim,1)>1)
        rsim=rsim'; 
    end
    robs = rsim(index_obs==1);
    rann = rsim(index==1);

    Xsel_sim = (1:(nPeriods)/prec);
    Xsel_obs = (1:(nPeriods)/freq)./prec*freq;
    Xsel_ann = (1:(nPeriods))./prec;

    rds=outr_rds(:,loop); 

    if (size(rds,1)>1)
        rds=rds'; 
    end
    for i = 1:size(Xsel_obs,2)
        rdsobs(i) = sum(rds(Xsel_obs(i)-(freq/prec-1):Xsel_obs(i)));
    end
    for i = 1:size(Xsel_ann,2)
        rdsann(i) = sum(rds(Xsel_ann(i)-(1/prec-1):Xsel_ann(i)));
    end

    y=outr_y(:,loop); 
    Asim = (exp(y));    
    
    if (size(Asim,1)>1)
        Asim=Asim'; 
    end
    Aobs = Asim(index_obs==1);
    Aann = Asim(index==1);
    
    xnorm=outr_xnorm(:,loop);
    Bsim_init=B_init(loop);
    Bsim = cumsum(xnorm)*sqrt(prec); Bsim =Bsim(1/prec+1:end);          
      
    if (size(Bsim,1)>1)
        Bsim=Bsim'; 
    end
    Bobs = Bsim(index_obs==1);
    Bann = Bsim(index==1);

    xnorm2=outr_xnorm2(:,loop);    
    Zsim_init=Z_init(loop);
    Zsim = cumsum(xnorm2)*sqrt(prec); Zsim =Zsim(1/prec+1:end);
    
    if (size(Zsim,1)>1)
        Zsim=Zsim'; 
    end
    Zobs = Zsim(index_obs==1);
    Zann = Zsim(index==1);

    xpois=outr_xpois(:,loop);
    
    Nsim_init=N_init(loop);
    Nsim = xpois; Nsim =Nsim(1/prec+1:end);
    if (size(Nsim,1)>1)
        Nsim=Nsim'; 
    end
    Nobs = Nsim(index_obs==1);
    Nann = Nsim(index==1);

    xpois2=outr_xpois2(:,loop);
    if (quiet ==1)
        xpois2(1:end)=0;
    end

    
    N2sim_init=N_init(loop);
    N2sim = xpois2; N2sim =N2sim(1/prec+1:end);
    if (size(N2sim,1)>1)
        N2sim=N2sim'; 
    end
    N2obs = N2sim(index_obs==1);
    N2ann = N2sim(index==1);

    if (solution == 3)
        SDFsim = exp(-rds-(-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-lambda_bar+exp(-gamma*nu_bar)*lambda_bar-gamma*alpha*sigma^2+1/2*(gamma*sigma_bar)^2+1/2*(alpha*gamma*sigma)^2)*prec-gamma*sigma_bar*(Bsim-[Bsim_init Bsim(1:(nPeriods/prec-1))])-alpha*gamma*sigma*(Zsim-[Zsim_init Zsim(1:(nPeriods/prec-1))])-alpha*gamma*nu*(N2sim-[N2sim_init N2sim(1:(nPeriods/prec-1))])-gamma*nu_bar*(Nsim-[Nsim_init Nsim(1:(nPeriods/prec-1))]));        
        SDFobs = exp(-rdsobs-(-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-lambda_bar+exp(-gamma*nu_bar)*lambda_bar-gamma*alpha*sigma^2+1/2*(gamma*sigma_bar)^2+1/2*(alpha*gamma*sigma)^2)*freq-gamma*sigma_bar*(Bobs-[Bsim_init Bobs(1:(nPeriods/freq-1))])-alpha*gamma*sigma*(Zobs-[Zsim_init Zobs(1:(nPeriods/freq-1))])-alpha*gamma*nu*(N2obs-[N2sim_init N2obs(1:(nPeriods/freq-1))])-gamma*nu_bar*(Nobs-[Nsim_init Nobs(1:(nPeriods/freq-1))]));        
        SDFann = exp(-rdsann-(-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-lambda_bar+exp(-gamma*nu_bar)*lambda_bar-gamma*alpha*sigma^2+1/2*(gamma*sigma_bar)^2+1/2*(alpha*gamma*sigma)^2)-gamma*sigma_bar*(Bann-[Bsim_init Bann(1:(nPeriods-1))])-alpha*gamma*sigma*(Zann-[Zsim_init Zann(1:(nPeriods-1))])-alpha*gamma*nu*(N2ann-[N2sim_init N2ann(1:(nPeriods-1))])-gamma*nu_bar*(Nann-[Nsim_init Nann(1:(nPeriods-1))]));        
        Rsim_risk = exp(rds+(-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-gamma*alpha*sigma^2+1/2*(alpha*gamma*sigma)^2)*prec+alpha*sigma*gamma*(Zsim-[Zsim_init Zsim(1:(nPeriods/prec-1))])+alpha*gamma*nu*(N2sim-[N2sim_init N2sim(1:(nPeriods/prec-1))]));
        Robs_risk = exp(rdsobs+(-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-gamma*alpha*sigma^2+1/2*(alpha*gamma*sigma)^2)*freq+alpha*sigma*gamma*(Zobs-[Zsim_init Zobs(1:(nPeriods/freq-1))])+alpha*gamma*nu*(N2obs-[N2sim_init N2obs(1:(nPeriods/freq-1))]));
        Rann_risk = exp(rdsann-delta-lambda2+exp((1-alpha*gamma)*nu)*lambda2-gamma*alpha*sigma^2+1/2*(alpha*gamma*sigma)^2+alpha*sigma*gamma*(Zann-[Zsim_init Zann(1:(nPeriods-1))])+alpha*gamma*nu*(N2ann-[N2sim_init N2ann(1:(nPeriods-1))]));
    end

    Rsim_bill = exp(rds-RP*prec-delta*prec);
    Robs_bill = exp(rdsobs-RP*freq-delta*freq);
    Rann_bill = exp(rdsann-RP-delta);

    Rsim_free = Rsim_bill;
    Robs_free = Robs_bill;
    Rann_free = Rann_bill;
    
    % adding measurement errors
    if eta~=0
        Robs_free_measured = Robs_free.*exp(eta*(Z2obs-[Z2sim_init Z2obs(1:(nPeriods/freq-1))]));
        Robs_risk_measured = Robs_risk;
    end
    
    Robs_risk_excl = Robs_risk;
    euler_bill = NaN;
    euler_risk = NaN;

    k=outr_k(:,loop);
    Ksim = (exp(k));
    
    if (size(Ksim,1)>1)
        Ksim=Ksim'; 
    end
    Kobs = Ksim(index_obs==1);
    Kann = Ksim(index==1);

    gsim_K = (log(Ksim)-log([Ksim_init Ksim(1:(end-1))]));
    gobs_K = (log(Kobs)-log([Ksim_init Kobs(1:(end-1))]));
    gann_K = (log(Kann)-log([Ksim_init Kann(1:(end-1))]));

    gsim_A = (log(Asim)-log([Asim_init Asim(1:(end-1))]));
    gobs_A = (log(Aobs)-log([Asim_init Aobs(1:(end-1))]));
    gann_A = (log(Aann)-log([Asim_init Aann(1:(end-1))]));

    if (solution == 3)
        gsim = gsim_A + alpha*gsim_K;
        gobs = gobs_A + alpha*gobs_K;
        gann = gann_A + alpha*gann_K;
    end
end

if (solution == 4)
%     load(['LRR/'  'LRR_Sim_',simversion,'.mat']);   
    Robs_bill = rbond_qoq(:,loop)';
    Robs_free = Robs_bill;
    % risky asset excluding dividends
    Robs_risk_excl = [NaN, Pd_qoq(2:end,loop)'./Pd_qoq(1:end-1,loop)'];
    Robs_risk_strp = 1+rc_qoq(:,loop)'-Robs_risk_excl;
    Robs_risk = Robs_risk_excl+Robs_risk_strp-1;
    gobs = dc_qoq(:,loop)';
    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% End of file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%