% Realization of stochastic processes

clear xbins xnorm xnorm2 xnorm3 xjump xjump2 xdefs s xpois xpois2 

if (lambda ~= 0)
    xexp = -log(rand(1))/lambda; % replaces random('Exponential',1/lambda,1);
    s = xexp;
    % the Binomial distribution where 1 denotes default and 0 no default
    xbins = random('Binomial',1,q,1);          % default events
    xdefs = (exp(kappa)-1)*xbins;              % default size
    xjump = exp(nu_bar)-1;                     % jump size
    % n denotes the number of arrivals in the ttime interval [0,t[
    n = 1;
    xpois(1:min(floor(s/prec),nPeriods/prec)) = n-1;
    while s(n)<nPeriods
        xexp = -log(rand(1))/lambda;% replaces random('Exponential',1/lambda,1);
        s = ([s s(n)+xexp]);
        n=n+1;
        xbins(n) = random('Binomial',1,q,1);   % default events
        xdefs(n) = (exp(kappa)-1)*xbins(n);    % default size
        xjump(n) = exp(nu_bar)-1;              % jump size
        xpois((length(xpois)+1):min(floor(s(n)/prec),nPeriods/prec))=n-1;
    end
%     n = 1;
else
    xjump = 0;
    xdefs = 0;
    xbins = 0;
    xpois(1:nPeriods/prec)=0;
end

if (lambda2 ~= 0)
    xexp2 = -log(rand(1))/lambda2; % random('Exponential',1/lambda2,1);
    s2 = xexp2;
    xjump2 = exp(nu)-1;                        % jump size
    % n denotes the number of arrivals in the ttime interval [0,t[
    n = 1;
    xpois2(1:min(floor(s2/prec),nPeriods/prec)) = n-1;
    while s2(n)<nPeriods
        xexp2 = -log(rand(1))/lambda2; % random('Exponential',1/lambda2,1);
        s2 = ([s2 s2(n)+xexp2]);
        n=n+1;
        xjump2(n) = exp(nu)-1;                         % jump size
        xpois2((length(xpois2)+1):min(floor(s2(n)/prec),nPeriods/prec))=n-1;
    end
else
    xjump2 = 0;
    xpois2(1:nPeriods/prec)=0;
end

% white noise processes with mean 0 and variance 1
xnorm  = randn(1,nPeriods/prec); % replaces random('Normal',0,1,1,nPeriods/prec);
xnorm2 = randn(1,nPeriods/prec); % replaces random('Normal',0,1,1,nPeriods/prec);
xnorm3 = randn(1,nPeriods/prec); % replaces random('Normal',0,1,1,nPeriods/prec);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% End of file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%